> For the complete documentation index, see [llms.txt](https://docs.metaproprotocol.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.metaproprotocol.com/developer-documentation/implementing-meta-assets-into-your-game/displaying-all-user-owned-tokens.md).

# Displaying All User-Owned Tokens

In this section, you will learn how to display all the tokens owned by a specific user. However, if you wish **to showcase only the tokens directly related to your game on your platform,** refer to the example provided in the previous section. Utilize the parameter **tokens\[ContractAddress]=\[TokenIDs]** to precisely define which tokens should be included in the displayed results. This mechanism allows for the customization of token visibility according to specified criteria, tailoring the presented information to the specifics of your game.

**NFT Service:** <https://api.metaproprotocol.com/ms/nft/docs/#/>

## Returns tokens from that are owned by a specific User

<mark style="color:blue;">`GET`</mark> `../v1/user/{address}/tokens`

#### Query Parameters

| Name                                      | Type           | Description |
| ----------------------------------------- | -------------- | ----------- |
| skip                                      | number         |             |
| limit                                     | number         |             |
| contractAddress                           | string         |             |
| standard                                  | string         |             |
| protocol                                  | string         |             |
| network                                   | array\[string] |             |
| categoryIds                               | array\[number] |             |
| \_items                                   | boolean        |             |
| networks                                  | array\[string] |             |
| id                                        | number         |             |
| protocols                                 | array\[string] |             |
| sort                                      | object         |             |
| address<mark style="color:red;">\*</mark> | string         |             |
| toknes                                    | object         |             |
| skipTokens                                | String         |             |

{% tabs %}
{% tab title="200: OK " %}

```json
{
    "results": [
        {
            "_id": "63341a5e626025ac7c4511af",
            "address": "0xa293d68684be29540838dc8a0222de0c43c6b5b4",
            "createdBy": "0x62199ec934c1b4ae52dfa8064964f2332acbb0d5",
            "contractAddress": "0xa293d68684be29540838dc8a0222de0c43c6b5b4",
            "standard": "erc1155",
            "protocol": "metaprotocol",
            "network": "bnb-chain",
            "chainId": 56,
            "creationBlock": 21722028,
            "version": 0,
            "isListed": false,
            "isAsset": true,
            "createdAt": "2022-09-28T09:56:46.051Z",
            "__v": 0,
            "owner": {
                "_id": "63341a5e626025ac7c4511b7",
                "address": "0xa293d68684be29540838dc8a0222de0c43c6b5b4",
                "owner": "0x832735f45299c8b6f7263e758cadba766459cd21",
                "_tokenId": 1001,
                "_quantity": 41,
                "role": [],
                "socialMedia": [],
                "createdAt": "2022-09-28T09:56:46.842Z",
                "updatedAt": "2023-09-10T20:49:39.981Z"
            },
            "token": {
                "_id": "63341a5e9832b155f241b695",
                "_tokenId": 1001,
                "address": "0xa293d68684be29540838dc8a0222de0c43c6b5b4",
                "_quantity": 100,
                "burn": false,
                "createdAt": "2022-09-28T09:56:46.550Z",
                "createdBy": "0x832735f45299c8b6f7263e758cadba766459cd21",
                "creationBlock": 21722028,
                "description": "MetaDude is a ready-to-import into Unity, low polly, full-body, textured 3D avatar with standard Mixamo rig.  ",
                "image": "https://prd-pod-1.metaprotocol.one/0x03e9/preview",
                "initialOwner": "0x832735f45299c8b6f7263e758cadba766459cd21",
                "owner": "0x832735f45299c8b6f7263e758cadba766459cd21",
                "properties": {},
                "tokenName": "MetaDude",
                "transactionHash": "0xfcb5da8a77f4d312476911fb43e63a9b9a445788cc916ca6bc16c0c880aa3344",
                "updatedAt": "2023-04-07T16:16:55.340Z",
                "favorites": 8,
                "extraFiles": [],
                "minifiedImage": "https://prdmetapropreviews.blob.core.windows.net/previews/0xa293D68684Be29540838Dc8A0222De0c43c6b5B4_1001.webp",
                "filesSpec": {
                    "item_experiance": [],
                    "common": {
                        "standard": [
                            {
                                "key": "asset_tags",
                                "value": [
                                    "avatar",
                                    "Unity",
                                    "full-body",
                                    "Mixamo"
                                ],
                                "value_type": "string array"
                            },
                            {
                                "key": "asset_tag_ids",
                                "value": [
                                    13,
                                    14,
                                    15,
                                    16
                                ],
                                "value_type": "integer array"
                            },
                            {
                                "key": "asset_category",
                                "value": "Avatars",
                                "value_type": "string"
                            },
                            {
                                "key": "asset_subcategories",
                                "value": [
                                    "Body shape"
                                ],
                                "value_type": "string array"
                            },
                            {
                                "key": "asset_category_ids",
                                "value": [
                                    18,
                                    19
                                ],
                                "value_type": "integer array"
                            }
                        ],
                        "2d_spec": [],
                        "3d_spec": [
                            {
                                "key": "asset_geometry",
                                "value": "Polygonal Quads/Tris",
                                "value_type": "string"
                            },
                            {
                                "key": "asset_polygons",
                                "value": 7230,
                                "value_type": "integer"
                            },
                            {
                                "key": "asset_vertices",
                                "value": 21690,
                                "value_type": "integer"
                            },
                            {
                                "key": "asset_materials",
                                "value": true,
                                "value_type": "boolean"
                            },
                            {
                                "key": "asset_textures",
                                "value": true,
                                "value_type": "boolean"
                            },
                            {
                                "key": "asset_uv_mapped",
                                "value": true,
                                "value_type": "boolean"
                            },
                            {
                                "key": "asset_animated",
                                "value": true,
                                "value_type": "boolean"
                            }
                        ],
                        "sound_spec": []
                    }
                }
            }
        }
    ],
    "count": 23
}
```

{% endtab %}

{% tab title="400: Bad Request " %}

```json
{
    "statusCode": 400,
    "messages": [
        "Some Message"
    ],
    "error": "Bad Request"
}
```

{% endtab %}

{% tab title="404: Not Found " %}

```json
{​
  "statusCode": 404,​
  "messages": [​
    "Not found!"​
  ],​
  "error": "Not Found"​
​}
```

{% endtab %}
{% endtabs %}

<details>

<summary>Example cURL</summary>

{% code overflow="wrap" %}

```bash
curl --location 'https://api.metaproprotocol.com/ms/nft/v1/user/0x832735f45299c8b6f7263e758cadba766459cd21/tokens' \
--header 'accept: application/json'
```

{% endcode %}

</details>

***

For more information about the Endpoints from the NFT Service, use the documentation below&#x20;

{% content-ref url="/spaces/9QQIPimQeOGE3C1HbWxf/pages/RDBZRYOqAhBowQ7LZv0V" %}
[API](/metapro-protocol/api.md)
{% endcontent-ref %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.metaproprotocol.com/developer-documentation/implementing-meta-assets-into-your-game/displaying-all-user-owned-tokens.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
